##################################
##    DIACRITICAL CHARACTERS    ##
##         v1.01 for tml        ##
## by Piotr Kowalewski (komame) ##
##    This is a demonstration   ##
## program using the tml module ##
##         for HP Prime         ##
##  September - October, 2024   ##
##################################

import tml
import sys
import urandom
from hpprime import eval as ppleval

char_map = {
    'À':  95, 'Á':  96, 'Â':  97, 'Ã':  98, 'Ä':  99, 'Æ': 100,
    'Ç': 101, 'È': 102, 'É': 103, 'Ê': 104, 'Ë': 105, 'Ì': 106,
    'Í': 107, 'Î': 108, 'Ï': 109, 'Ñ': 110, 'Ò': 111, 'Ó': 112,
    'Ô': 113, 'Õ': 114, 'Ö': 115, 'Œ': 116, 'Ù': 117, 'Ú': 118,
    'Û': 119, 'Ü': 120, 'Ÿ': 121, 'à': 122, 'á': 123, 'â': 124,
    'ã': 125, 'ä': 126, 'æ': 127, 'ç': 128, 'è': 129, 'é': 130,
    'ê': 131, 'ë': 132, 'ì': 133, 'í': 134, 'î': 135, 'ï': 136,
    'ñ': 137, 'ò': 138, 'ó': 139, 'ô': 140, 'õ': 141, 'ö': 142,
    'œ': 143, 'ù': 144, 'ú': 145, 'û': 146, 'ü': 147, 'ÿ': 148,
    'ß': 149, '¿': 150, '¡': 151
}

key_map = {
  # no modifiers, Alpha, Shift, Alpha+Shift
  14: [None,['à','á','â','ã','ä','æ'],None,['À','Á','Â','Ã','Ä','Æ']],
  16: [None,['ç'],None,['Ç']],
  18: [None,['è','é','ê','ë'],None,['È','É','Ê','Ë']],
  23: [None,['ì','í','î','ï'],None,['Ì','Í','Î','Ï']],
  28: [None,['ñ'],None,['Ñ']],
  29: [None,['ò','ó','ô','õ','ö','œ'],None,['Ò','Ó','Ô','Õ','Ö','Œ']],
  34: [None,['ß'],None,['ß']],
  37: [None,['ù','ú','û','ü'],None,['Ù','Ú','Û','Ü']],
  42: [None,['ÿ'],None,['Ÿ']],
  48: [None,['¡','¿'],None,['¡','¿']]
  }
  
t=tml.tml(font='med10x12d', ext_char_map = char_map, symb_key_map = key_map)
t.print('Diacritical characters test.\nTo enter diacritical characters,press and hold the [Symb] key\nand simultaneously press one of the following keys:\na, c, e, i, n, o, s, u, y\nor . (dot).\n')
t.print('Press Enter (no input) to exit.')
inp = None
while inp != '':
    inp = t.input('>')
