###############################
###   INOUT v1.01 for tml   ###
###   by Piotr Kowalewski   ###
### This is a demonstration ###
###     program using       ###
###     the tml module      ###
###      for HP Prime       ###
###   September 26, 2024    ###
###############################
import tml
from hpprime import eval as ppleval, keyboard as kb

# Initialize tml with font 5x10 in dark mode
t=tml.tml(dark_mode=True)

# Get user data
n=None
while n == None or len(n) == 0:
  n=t.input('Enter your name: ')

t.print('\nHello, %s!' % n)
t.print()
t.print('Press any key...')
t.read_key()

# Print O-triangle
for i in range(1, 12):
  t.print('O' * i)
for i in range(9, 0, -1):
  t.print('O' * i)
	
t.print('Press any key to scroll the screen')
t.read_key()

for i in range(23):
  t.print()

t.print('\nNow type some text, numbers, and symbols using the Alpha\nand Shift keys (watch the keyboard indicator on the status bar)')
txt = t.input('Your text: ')

t.print('\nNow you will type text in lowercase (Alpha has been enabled\nautomatically, so you only need to press the letter keys)')
txt = t.input('Your lowercase text: ') # alpha default is True

t.print('\nNow type some numbers (Alpha has been disabled, so you can\npress the number keys directly)')
txt = t.input('Your numbers: ',alpha=False)

t.print('\nNow you will type text in UPPERCASE (Alpha and Shift have\nbeen enabled)')
txt = t.input('Your uppercase text: ',alpha=True,shift=True)

t.print('\nNow type some short text to display on the status bar.')
txt = t.input('Your future status bar content: ', length=30)

t.set_status(txt)
t.read_key()

t.clear()

txt = ' '*65 + 'This is scrolling text using the print_xy() function. You can also position the cursor anywhere on the screen with set_cursor(). Using clear(), you can clear the screen (which will set the cursor to position [0,0]). Press Esc to exit the program. '

x = 0
while not kb() & 16:
  t.print_xy(0,10,txt[x:x+64])
  ppleval('WAIT(1/10)')
  x += 1
  if x > len(txt):
    x=0
